function onListsLoad() {
  this.profile = window.arguments[0];
  this.allowList = document.getElementById("allow-list");
  this.blockList = document.getElementById("block-list");
  var allowListContacts = this.profile.getListContacts("AL");
  var blockListContacts = this.profile.getListContacts("BL");
  for (var email in allowListContacts) {
    var contact = allowListContacts[email];
    var label = "";
    if (contact.displayName == contact.email) {
      label = contact.email;
    }
    else {
      label = contact.displayName + " <" + contact.email + ">";
    }
    this.allowList.appendItem(label, contact.email);
  }
  for (var email in blockListContacts) {
    var contact = blockListContacts[email];
    var label = "";
    if (contact.displayName == contact.email) {
      label = contact.email;
    }
    else {
      label = contact.displayName + " <" + contact.email + ">";
    }
    this.blockList.appendItem(label, contact.email);
  }
}

function onAllowContactCommand() {
  if (this.blockList.selectedItem) {
    this.profile.blockContact(this.blockList.selectedItem.value);
  }
}

function onAllowListSelectCommand() {
  if (this.allowList.selectedItem) {
    var contactId = this.allowList.value;
    var deletable = this.profile.isContactDeletable(contactId);
    document.getElementById("allow-remove-button").disabled = !deletable;
  }
}

function onBlockContactCommand() {
  if (this.allowList.selectedItem) {
    this.profile.blockContact(this.allowList.selectedItem.value);
  }
}

function onBlockListSelectCommand() {
  if (this.blockList.selectedItem) {
    var contactId = this.blockList.value;
    var deletable = this.profile.isContactDeletable(contactId);
    document.getElementById("block-remove-button").disabled = !deletable;
  }
}

function onContactAddedToList(aListName, aContactId, aDisplayName) {
  var list = (aListName == "AL") ? this.allowList : this.blockList;
  var label = "";
  if (aDisplayName == aContactId) {
    label = aContactId;
  }
  else {
    label = aDisplayName + " <" + aContactId + ">";
  }
  list.appendItem(label, aContactId);
}

function onContactRemovedFromList(aListName, aContactId) {
  var list = (aListName == "AL") ? this.allowList : this.blockList;
  var rowCount = list.getRowCount();
  for (var i in rowCount) {
    if (list.getItemAtIndex(i).value == aContactId) {
      list.removeItemAt(i);
    }
  }
}

function onRemoveContactFromAllowListCommand() {
  var contactId = this.allowList.selectedItem.value;
  this.profile.removeDeletableContact(contactId);
  document.getElementById("allow-remove-button").disabled = true;
  var itemIndex = this.allowList.selectedIndex;
  this.allowList.removeItemAt(itemIndex);
}

function onRemoveContactFromBlockListCommand() {
  var contactId = this.blockList.selectedItem.value;
  this.profile.removeDeletableContact(contactId);
  document.getElementById("block-remove-button").disabled = true;
  var itemIndex = this.blockList.selectedIndex;
  this.blockList.removeItemAt(itemIndex);
}