var fontEnumerator = null;
var displayPictureChanged = false;

function onPrefsLoad() {
  var count = { value: 0 }
  var fonts = getFontEnumerator().EnumerateAllFonts(count);
  var fontList = document.getElementById("font-picker").firstChild;
  for (var font in fonts) {
    font = fonts[font];
    var itemNode = document.createElement("menuitem");
    itemNode.setAttribute("value", font);
    itemNode.setAttribute("label", font);
    fontList.appendChild(itemNode);
  }
  var msnSession = window.arguments[0];
  var displayName = msnSession.displayName();
  document.getElementById("display-name").value = displayName;
  var displayPicture = Utils.getExtensionSubDirectory("pictures");
  var passport64 = btoa(msnSession.passport);
  displayPicture.append(passport64);
  if (displayPicture.exists()) {
    var fileUri = ioService.newFileURI(displayPicture);
    document.getElementById("display-picture").src = fileUri.spec;
  }
  document.getElementById("chk-emoticons").checked = Utils.getPref("getBoolPref", "show-emoticons", true);
  document.getElementById("font-picker").value = Utils.getPref("getCharPref", "font.name", "Arial");
  document.getElementById("font-color-picker").color = Utils.getPref("getCharPref", "font.color", "#000000");
  document.getElementById("chk-bold").checked = Utils.getPref("getBoolPref", "font.bold", false);
  document.getElementById("chk-italic").checked = Utils.getPref("getBoolPref", "font.italic", false);
  document.getElementById("chk-underline").checked = Utils.getPref("getBoolPref", "font.underline", false);
  document.getElementById("chk-strike").checked = Utils.getPref("getBoolPref", "font.strike", false);
}

function onChangeDisplayPictureCommand() {
  var filePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  filePicker.appendFilters(nsIFilePicker.filterImages);
  filePicker.init(window, "Choose the image file you want to use", nsIFilePicker.modeOpen);
  var filePickerResult = filePicker.show();
  if (filePickerResult == nsIFilePicker.returnOK) {
    var fileUri = ioService.newFileURI(filePicker.file);
    var image = new Image();
    image.onload = onDisplayPictureCandidateLoaded;
    image.src = fileUri.spec;
  }
}

function onDisplayPictureCandidateLoaded() {
  if (this.width == 96 && this.width == 96) {
    document.getElementById("display-picture").src = this.src;
    displayPictureChanged = true;
  }
  else {
    alert("Error: width = " + this.width + ", height = " + this.height);
  }
}

function doOK() {
  var msnSession = window.arguments[0];
  var oldDisplayName = msnSession.displayName;
  var newDisplayName = document.getElementById("display-name").value;
  if (newDisplayName != oldDisplayName && newDisplayName.replace(/^\s+|\s+$/, "")) {
    msnSession.changeDisplayName(newDisplayName);
  }
  if (displayPictureChanged) {
    var currentDisplayPicture = Utils.getExtensionSubDirectory("pictures");
    var passport64 = btoa(msnSession.passport);
    currentDisplayPicture.append(passport64);
    if (currentDisplayPicture.exists()) {
      currentDisplayPicture.remove(false);
    }
    var fileUriString = document.getElementById("display-picture").src;
    var fileUri = ioService.newURI(fileUriString, null, null);
    var newDisplayPicture = fileUri.QueryInterface(Components.interfaces.nsIFileURL).file;
    var displayPictureDirectory = Utils.getExtensionSubDirectory("pictures");
    newDisplayPicture.copyTo(displayPictureDirectory, passport64);
    msnSession.changeDisplayPicture();
  }
  var prefBranch = prefService.getBranch("extensions.msnmsgr.");
  prefBranch.setCharPref("display-picture-uri", document.getElementById("display-picture").src);
  prefBranch.setBoolPref("show-emoticons", document.getElementById("chk-emoticons").checked);
  prefBranch.setCharPref("font.name", document.getElementById("font-picker").value);
  prefBranch.setBoolPref("font.bold", document.getElementById("chk-bold").checked);
  prefBranch.setBoolPref("font.italic", document.getElementById("chk-italic").checked);
  prefBranch.setBoolPref("font.underline", document.getElementById("chk-underline").checked);
  prefBranch.setBoolPref("font.strike", document.getElementById("chk-strike").checked);
  prefBranch.setCharPref("font.color", document.getElementById("font-color-picker").color);
}

function getFontEnumerator() {
  if (!fontEnumerator) {
    fontEnumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"].createInstance().QueryInterface(Components.interfaces.nsIFontEnumerator);
  }
  return fontEnumerator;
}